import { HttpClient, EventDefinition, MaybeContext, BuildRESTFunction, BuildEventDefinition } from '@wix/sdk-types';
import { L as ListCategoriesOptions, a as ListCategoryResponse, C as Category, U as UpdateCategory, b as UpdateCategoryResponse, D as DeleteCategoryOptions, c as DeleteCategoryResponse, d as CategoryNotificationEnvelope } from './bookings-v1-category-categories.universal-DY7XN7m0.mjs';
export { q as BaseEventMetadata, B as BatchCreateCategoryRequest, i as BatchCreateCategoryResponse, l as BatchDeleteCategoryRequest, m as BatchDeleteCategoryResponse, n as BatchUpdateCategoryRequest, o as BatchUpdateCategoryResponse, f as CategoryNotification, g as CreateCategoryRequest, h as CreateCategoryResponse, k as DeleteCategoryRequest, E as Event, I as IdentificationData, p as IdentificationDataIdOneOf, e as ListCategoryRequest, M as MessageEnvelope, S as Status, j as UpdateCategoryRequest, W as WebhookIdentityType } from './bookings-v1-category-categories.universal-DY7XN7m0.mjs';

declare function listCategories$1(httpClient: HttpClient): ListCategoriesSignature;
interface ListCategoriesSignature {
    /**
     * Retrieves all categories.
     * @param - Options to use when listing categories.
     * @deprecated
     */
    (options?: ListCategoriesOptions | undefined): Promise<ListCategoryResponse>;
}
declare function createCategory$1(httpClient: HttpClient): CreateCategorySignature;
interface CreateCategorySignature {
    /**
     * Creates a category.
     * @param - Category to create.
     * @returns Created category.
     * @deprecated
     */
    (category: Category): Promise<Category>;
}
declare function updateCategory$1(httpClient: HttpClient): UpdateCategorySignature;
interface UpdateCategorySignature {
    /**
     * Updates a category.
     *
     *
     * Each time the category is updated, revision increments by 1. You must include
     * the number of the existing revision when updating the category. This ensures
     * you're working with the latest service information and prevents unintended
     * overwrites.
     * @param - Category ID.
     * @deprecated
     */
    (_id: string, category: UpdateCategory): Promise<UpdateCategoryResponse>;
}
declare function deleteCategory$1(httpClient: HttpClient): DeleteCategorySignature;
interface DeleteCategorySignature {
    /**
     * Deletes a category.
     *
     *
     * You can specify `{"deleteServices": true}` to also delete all associated
     * services. Learn more about *deleting a service*
     * ([SDK](https://dev.wix.com/docs/sdk/backend-modules/bookings/services/delete-service) | [REST](https://dev.wix.com/docs/rest/business-solutions/bookings/services/services-v2/delete-service)).
     * @param - ID of the category to delete.
     * @deprecated
     */
    (_id: string, options?: DeleteCategoryOptions | undefined): Promise<DeleteCategoryResponse>;
}
declare const onCategoryNotification$1: EventDefinition<CategoryNotificationEnvelope, "com.wixpress.bookings.services.api.v1.CategoryNotification">;

declare const listCategories: MaybeContext<BuildRESTFunction<typeof listCategories$1> & typeof listCategories$1>;
declare const createCategory: MaybeContext<BuildRESTFunction<typeof createCategory$1> & typeof createCategory$1>;
declare const updateCategory: MaybeContext<BuildRESTFunction<typeof updateCategory$1> & typeof updateCategory$1>;
declare const deleteCategory: MaybeContext<BuildRESTFunction<typeof deleteCategory$1> & typeof deleteCategory$1>;
/** @deprecated */
declare const onCategoryNotification: BuildEventDefinition<typeof onCategoryNotification$1>;

export { Category, CategoryNotificationEnvelope, DeleteCategoryOptions, DeleteCategoryResponse, ListCategoriesOptions, ListCategoryResponse, UpdateCategory, UpdateCategoryResponse, createCategory, deleteCategory, listCategories, onCategoryNotification, updateCategory };
